#include <bits/stdc++.h>
using namespace std;


template<class T, class Comp>
struct SparseTable {
    Comp comp;
    vector<vector<T>> t;
    vector<int> logs;

    template<class It>
    SparseTable(It from, It to) {
        int n = distance(from, to);
        logs.resize(n + 1);
        for (int i = 2; i <= n; ++i) {
            logs[i] = 1 + logs[i / 2];
        }
        int sz = logs[n] + 1;
        t.resize(sz);
        t[0].assign(from, to);
        for (int i = 1; i < sz; ++i) {
            t[i].resize(n);
            int len = 1 << i;
            for (int j = 0; j + len <= n; ++j) {
                t[i][j] = min(t[i - 1][j], t[i - 1][j + len / 2], comp);
            }
        }
    }

    T get(int from, int to) {
        int x = logs[to - from];
        return min(t[x][from], t[x][to - (1 << x)], comp);
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (int &x : a) {
        cin >> x;
    }
    vector<int> b(m);
    for (int &x : b) {
        cin >> x;
    }

    SparseTable<int, greater<int>> as(a.begin(), a.end());
    SparseTable<int, greater<int>> bs(b.begin(), b.end());

    long long answer = 0;
    for (int width = 1; width <= m; ++width) {
        int window = min(m, width + 1);
        int height = n;
        for (int i = 0; i + window <= m; ++i) {
            int cura = as.get(i, i + window);
            int curb = bs.get(i, i + window);
            height = min(height, n - cura - curb);
        }
        answer = max(answer, (long long) height * width);
    }

    cout << answer << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    int tests = 1;
    // cin >> tests;
    for (int i = 0; i < tests; ++i) {
        solve();
    }
}
