#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

#define ss second
#define ff first
#define y1 y111
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> ipair;
typedef pair <ll, ll> lpair;

const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

int find_dsu(int a, vector <int> &p) {
    return (a == p[a] ? a : p[a] = find_dsu(p[a], p));
}

void union_dsu(int a, int b, vector <int> &rnk, vector <int> &p) {
    a = find_dsu(a, p), b = find_dsu(b, p);
    if (a == b) return;
    if (rnk[b] > rnk[a]) p[a] = b;
    else if (rnk[a] > rnk[b]) p[b] = a;
    else rnk[b]++, p[a] = b;
}

int find (int x, int y, int n, map <ipair, int> &mp) {
    for (int i = 0; i < 4; ++i) {
        int nx = x + DX[i], ny = y + DY[i];
        if (mp[{nx, ny}] != 0) return mp[{nx, ny}];
    }
    return 0;
}

int main(int argc, char * argv[]) {
    setName("Checks the coordinates for the correctness");
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector <int> str(n), col(n);
    vector <int> a(n), p(n + 1), rnk(n + 1);
    map <ipair, int> mp;
    for (int i = 0; i < n; ++i) {
        a[i] = inf.readInt();
    }

    for (int i = 1; i <= n; ++i) {
        p[i] = i, rnk[i] = 1;
    }

    int x, y;
    for (int i = 1; i <= n; ++i) {
        x = ouf.readInt(1, n);
        y = ouf.readInt(1, n);
        x--, y--;
        if (str[x] != 0 && str[x] != a[i - 1]) {
            quitf(_wa, "There are two lasers of different types in the one line.");
        } else if (!str[x]) {
            str[x] = a[i - 1];
            mp[{x, y}] = i;
        } else if (find(x, y, n, mp)) {
            union_dsu(i, find(x, y, n, mp), rnk, p);
            mp[{x, y}] = i;
        }
        if (col[y] != 0 && col[y] != a[i - 1]) {
            quitf(_wa, "There are two lasers of different types in the one column.");
        } else if (!col[y]) {
            col[y] = a[i - 1];
            mp[{x, y}] = i;
        } else if (find(x, y, n, mp)) {
            union_dsu(i, find(x, y, n, mp), rnk, p);
            mp[{x, y}] = i;
        }
    }
    
    vector <int> v(n, 0);

    for (int i = 1; i <= n; ++i) {
        if (v[a[i - 1] - 1] && v[a[i - 1] - 1] != find_dsu(i, p)) {
            quitf(_wa, "There are two lasers of equal types which are not connected by power. %d", i);
        }
        v[a[i - 1] - 1] = find_dsu(i, p);
    }

    quitf(_ok, "OK");

    return 0;
}