import random
import math
random.seed("basic04/photorobot")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(['R.B', 'RBG', '..G'], ['117', '346', '006'])
        self.print_test(['R.B', 'RBG', '..G'], ['117', '346', '005'])

    def generate_min_tests(self):
        self.print_test(['.'], ['0'])
        self.print_test(['.'], ['1'])
        self.print_test(['.'], ['2'])
        self.print_test(['.'], ['4'])
        self.print_test(['.'], ['7'])
        for p in ['R', 'G', 'B']:
            for c in range(8):
                self.print_test([[p]], [[c]])

    def generate_hand_tests(self):
        pass

    def random_from_list(self, l):
            return l[random.randint(0, len(l) - 1)]

    def generate_correct_test(self, n, m):
        def generate_good_c(p):
            if p == '.':
                return random.randint(0, 7)
            elif p == 'R':
                return self.random_from_list([1, 3, 5, 7])
            elif p == 'G':
                return self.random_from_list([2, 3, 6, 7])
            else:
                return self.random_from_list([4, 5, 6, 7])

        pixels = [['.' for _ in range(m)] for _ in range(n)]
        c = [[0 for _ in range(m)] for j in range(n)]
        for i in range(n):
            for j in range(m):
                pixels[i][j] = self.random_from_list(['.', 'R', 'G', 'B'])
                c[i][j] = generate_good_c(pixels[i][j])
        return pixels, c

    def generate_random_correct_test(self, n, m):
        p, c = self.generate_correct_test(n, m)
        self.print_test(p, c)

    def generate_random_incorrect_test(self, n, m):
        def generate_bad_c(p):
            if p == 'R':
                return self.random_from_list([2, 4, 6])
            elif p == 'G':
                return self.random_from_list([1, 4, 5])
            else:
                return self.random_from_list([1, 2, 3])

        p, c = self.generate_correct_test(n, m)
        i = random.randint(0, len(p) - 1)
        j = random.randint(0, len(p[0]) - 1)
        while p[i][j] == '.':
            i = random.randint(0, len(p) - 1)
            j = random.randint(0, len(p[0]) - 1)
        c[i][j] = generate_bad_c(p[i][j])
        self.print_test(p, c)

    def generate_max_tests(self, maxn, maxm):
        pass        

    def print_test(self, p, c):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(p), len(p[0]), file=test_file)
        for i in range(len(p)):
            if type(p[i]) == list:
                print(''.join(p[i]), file=test_file)
            elif type(p[i]) == str:
                print(p[i], file=test_file)
            else:
                raise Exception('Failed to print test')
        for i in range(len(p)):
            if type(c[i]) == list:
                print(''.join(map(str, c[i])), file=test_file)
            elif type(c[i]) == str:
                print(c[i], file=test_file)
            else:
                raise Exception('Failed to print test')
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()

        for n in [3, 10, 50, 100]:
            for m in [3, 10, 50, 100]:
                self.generate_random_correct_test(n, m)
                self.generate_random_incorrect_test(n, m)
        self.generate_random_correct_test(1, 100)
        self.generate_random_incorrect_test(1, 100)
        self.generate_random_correct_test(100, 1)
        self.generate_random_incorrect_test(100, 1)
        self.generate_max_tests(100, 100)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
