import random
import math
random.seed("basic04/lock")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([[2, 4], [2, 5], [2, 6]])
        self.print_test([[2, 4], [2, 6], [6, 4]])

    def generate_min_tests(self):
        self.print_test([[1, 3]])
        self.print_test([[4, 2]])
        self.print_test([[1, 3], [1, 4]])
        self.print_test([[1, 3], [5, 3]])
        self.print_test([[1, 4], [2, 4]])
        self.print_test([[5, 2], [3, 5]])
        self.print_test([[5, 2], [2, 4]])

    def generate_hand_tests(self):
        self.print_test([[1, 3], [1, 4], [1, 5], [1, 6]])
        self.print_test([[1, 5], [1, 4], [2, 4], [1, 6]])
        self.print_test([[1, 5], [1, 4], [2, 4], [5, 7]])
        self.print_test([[1, 5], [1, 4], [2, 4], [5, 8], [8, 6]])

    def generate_random_test(self, n):
        a = []
        def helper(vs):
            if len(vs) <= 3:
                return
            l = random.randint(0, len(vs) - 1)
            r = random.randint(0, len(vs) - 1)
            while l == r or (l + 1) % len(vs) == r or (r + 1) % len(vs) == l:
                l = random.randint(0, len(vs) - 1)
                r = random.randint(0, len(vs) - 1)
            a.append([vs[l] + 1, vs[r] + 1])
            l, r = min(l, r), max(l, r)
            helper(vs[l:r + 1])
            helper(vs[r:] + vs[:l + 1])

        helper([i for i in range(n)])
        random.shuffle(a)
        self.print_test(a)

    def generate_max_tests(self, n):
        a = []
        ind = random.randint(0, n - 1)
        for i in range(n):
            if (i + 1) % n == ind or i == ind or (ind + 1) % n == i:
                continue
            a.append([i + 1, ind + 1])
        random.shuffle(a)
        self.print_test(a)

    def print_test(self, edges):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(edges) + 3, file=test_file)
        for edge in edges:
            print(' '.join(map(str, edge)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()

        for n in [10, 50, 100, 500, 10**3, 5 * 10**3, 10**4, 5 * 10**4, 10**5]:
            for i in range(5):
                self.generate_random_test(n)
        self.generate_max_tests(10**5)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
