#include "testlib.h"

const int MAX_N = 1e5;

int main(int argc, char* argv[])
{
  registerValidation(argc, argv);
  int n = inf.readInt(4, MAX_N, "n");
  inf.readEoln();
  std::set<std::pair<int, int>> used;
  std::vector<std::pair<int, int>> rs(n, {-1, -1});
  for (int i = 0; i < n - 3; i++) {
    int a = inf.readInt(1, n, ("from[" + std::to_string(i + 1) + "]").c_str());
    inf.readSpace();
    int b = inf.readInt(1, n, ("to[" + std::to_string(i + 1) + "]").c_str());
    inf.readEoln();
    ensuref(a != b && a % n != (b + n - 1) % n && b % n != (a + n - 1) % n, "edge #%d is either a loop or a polygon edge", i + 1);
    ensuref(used.count({a, b}) == 0 && used.count({b, a}) == 0, "duplicate edge (%d, %d)", a, b);
    used.insert({a, b});
    used.insert({b, a});

    int l = std::min(a, b) - 1;
    int r = std::max(a, b) - 1;
    if (rs[l].first < r) {
      rs[l] = {r, i};
    }
  }
  inf.readEof();
  
  std::vector<std::vector<int>> events;
  for (int i = 0; i < n; i++) {
    if (rs[i].first != -1) {
      events.push_back({i, -1, rs[i].second});
      events.push_back({rs[i].first, 1, rs[i].second});
    }
  }
  
  std::sort(events.begin(), events.end(), [&](std::vector<int> &a, std::vector<int> &b) {
    return a[0] < b[0] || (a[0] == b[0] && a[1] > b[1]);
  });

  std::vector<int> ids;
  for (int i = 0; i < (int)events.size();) {
    if (events[i][1] == -1) {
      ids.push_back(events[i][2]);
      i++;
    } else {
      std::vector<int> xs;
      int i0 = i;
      while (i < (int)events.size() && events[i][0] == events[i0][0] && events[i][1] == 1) {
        xs.push_back(events[i][2]);
        i++;
      }
      std::vector<int> idsback;
      for (int j = 0; j < (int)xs.size(); j++) {
        ensuref(ids.size() > 0, "Internal validator error");
        idsback.push_back(ids.back());
        ids.pop_back();
      }
      std::sort(xs.begin(), xs.end());
      std::sort(idsback.begin(), idsback.end());
      for (int j = 0; j < (int)xs.size(); j++) {
        ensuref(xs[j] == idsback[j], "Segment #%d and #%d are intersecting", xs[j] + 1, idsback[j] + 1);
      }
    }
  }
  return 0;
}
