#include "testlib.h"
#include <vector>

using namespace std;

const int MAXN = 100'000;
const int MAXX = 1'000'000'000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();

    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        if (i != 0) {
            inf.readSpace();
        }
        x[i] = inf.readInt(-MAXX, MAXX, format("x[%d]", i));
        ensuref(x[i] != 0, "x[%d] is 0", i);
    }
    inf.readEoln();

    for (int i = 0; i + 1 < n; i++) {
        ensuref(x[i] < x[i + 1], "x[%d] >= x[%d] :(", i, i + 1);
    }

    vector<int> y(n);
    for (int i = 0; i < n; i++) {
        if (i != 0) {
            inf.readSpace();
        }
        y[i] = inf.readInt(-MAXX, MAXX, format("y[%d]", i));
        ensuref(y[i] != 0, "y[%d] is 0", i);
    }
    inf.readEoln();

    for (int i = 0; i + 1 < n; i++) {
        ensuref(y[i] < y[i + 1], "y[%d] >= y[%d] :(", i, i + 1);
    }

    inf.readEof();

    return 0;
}
