#include <bits/stdc++.h>

const int MOD = 998244353;
const int maxn = 1e5 + 10;

long long f[maxn];

long long power(long long a, long long b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        long long x = power(a, b / 2);
        return (x * x) % MOD;
    } else {
        return (power(a, b - 1) * a) % MOD;
    }
}

long long inv(long long a, long long mod) {
    return power(a, mod - 2);
}

long long divide(long long a, long long b) {
    return (a * inv(b, MOD)) % MOD;
}

long long cnk(int n, int k) {
    if (0 <= k && k <= n) {
        long long b = (f[k] * f[n - k]) % MOD;
        return divide(f[n], b);
    }
    return 0;
}

int main() {
    f[0] = 1;
    for (int i = 1; i < maxn; i++) {
        f[i] = (f[i - 1] * i) % MOD;
    }

    int n;
    std::cin >> n;
    int posx = 0;
    int negx = 0;
    int posy = 0;
    int negy = 0;
    for (int i = 0; i < n; i++) {
        int x;
        std::cin >> x;
        if (x > 0) {
            posx++;
        } else {
            negx++;
        }
    }
    for (int i = 0; i < n; i++) {
        int y;
        std::cin >> y;
        if (y > 0) {
            posy++;
        } else {
            negy++;
        }
    }

    long long ans = 0;
    for (int points = 0; points <= n; points++) {
        int pos = posx - points;
        int diff = negy - pos;
        int neg = negx - diff;

        if (pos >= 0 && diff >= 0 && neg >= 0) {
            long long cntx = (cnk(posx, points) * cnk(negx, diff)) % MOD;
            long long cnty = (cnk(posy, points) * cnk(negy, diff)) % MOD;
            ans = (ans + (cntx * cnty) % MOD) % MOD;
        }
    }

    std::cout << ans << '\n';
    return 0;
}
