#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long pow(long long a, long long b, long long m) {
    if (b == 0) return 1;
    long long x = pow(a, b / 2, m);
    if (b % 2 == 0) {
        return x * x % m;
    } else {
        return x * x % m * a % m;
    }
}

long long div(long long a, long long b, long long m) {
    return a * pow(b, m - 2, m)% m;
}

long long c(int n, int k, long long m, const vector<long long>& fact) {
    if (k < 0 || k > n) return 0;
    return div(fact[n], fact[k] * fact[n - k] % m, m);
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    const int MOD = 998244353;

    int n;
    cin >> n;
    int xp = 0, xn = 0, yp = 0, yn = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x > 0) {
            xp++;
        } else {
            xn++;
        }
    }
    for (int i = 0; i < n; i++) {
        int y;
        cin >> y;
        if (y > 0) {
            yp++;
        } else {
            yn++;
        }
    }

    vector<long long> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }

    long long ans = 0;
    for (int pp = 0; pp <= n; pp++) {
        int pn = xp - pp;
        int nn = yn - pn;
        int np = xn - nn;

        if (pn >= 0 && nn >= 0 && np >= 0) {
            long long vx = 1LL * c(xp, pp, MOD, fact) * c(xn, nn, MOD, fact) % MOD;
            long long vy = 1LL * c(yp, pp, MOD, fact) * c(yn, nn, MOD, fact) % MOD;
            ans += vx * vy % MOD;
        }
    }

    cout << ans % MOD << endl;

    return 0;
}
