#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MOD = 998244353;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    int xp = 0, xn = 0, yp = 0, yn = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x > 0) {
            xp++;
        } else {
            xn++;
        }
    }
    for (int i = 0; i < n; i++) {
        int y;
        cin >> y;
        if (y > 0) {
            yp++;
        } else {
            yn++;
        }
    }

    vector<vector<int>> c(n + 1, vector<int> (n + 1));
    c[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            c[i][j] = c[i - 1][j] + (j > 0 ? c[i - 1][j - 1] : 0);
            if (c[i][j] >= MOD) {
                c[i][j] -= MOD;
            }
        }
    }

    long long ans = 0;
    for (int pp = 0; pp <= n; pp++) {
        int pn = xp - pp;
        int nn = yn - pn;
        int np = xn - nn;

        if (pn >= 0 && nn >= 0 && np >= 0) {
            long long vx = 1LL * c[xp][pp] * c[xn][nn] % MOD;
            long long vy = 1LL * c[yp][pp] * c[yn][nn] % MOD;
            ans += vx * vy % MOD;
        }
    }

    cout << ans % MOD << endl;

    return 0;
}
