#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<pair<int, int>> test) 
{
    cout << test.size() + 1 << endl;
    for (int i = 0; i < (int)test.size(); i++)
        cout << test[i].first << ' ' << test[i].second << endl;
}

vector<pair<int, int>> getEdges(vector<int>& p)
{
    int n = p.size();
    vector<int> a(n);
    iota(a.begin(), a.end(), 1);
    shuffle(a.begin(), a.end());
    vector<pair<int, int>> e;
    for (int i = 1; i < n; i++)
    {   
        if (rnd.next(2))
            e.push_back({a[p[i]], a[i]});
        else 
            e.push_back({a[i], a[p[i]]});
    }
    shuffle(e.begin(), e.end());
    return e;
}

void gen_star(int n, int x)
{
    assert(x <= n);
    vector<int> p(n, -1);
    for (int i = 1; i < x; i++)
        p[i] = i - 1;
    for (int i = x; i < n; i++)
        p[i] = 0;    
    write_test(getEdges(p));
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    if (argc > 3 && atoi(argv[3]) == 1)
        n = rnd.next(n / 2, n);
    int x = n;
    if (argc > 2)
        x = atoi(argv[2]);
    if (x == -1)
        x = rnd.next(n / 5);
    x = min(x, n);
    gen_star(n, x);
    return 0;
}